##// END OF EJS Templates
Update rpi23-gen-image.sh
burnbabyburn -
r633:16f87ddc718b
parent child
Show More
@@ -1,886 +1,886
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 # Kernel Branch
48 # Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62
62
63 # Kernel deb packages for 32bit kernel
63 # Kernel deb packages for 32bit kernel
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 # Default precompiled 64bit kernel
68 # Default precompiled 64bit kernel
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 # Sakaki BIS Kernel RPI4
70 # Sakaki BIS Kernel RPI4
71 RPI4_64_DEF_KERNEL_URL=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz
71 RPI4_64_DEF_KERNEL_URL=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz
72 # Generic
72 # Generic
73 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
73 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
74 RPI4_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
74 RPI4_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
75 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
75 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
76 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
76 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
77
77
78 # Build directories
78 # Build directories
79 WORKDIR=$(pwd)
79 WORKDIR=$(pwd)
80 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
80 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
81 BUILDDIR="${BASEDIR}/build"
81 BUILDDIR="${BASEDIR}/build"
82
82
83 # Chroot directories
83 # Chroot directories
84 R="${BUILDDIR}/chroot"
84 R="${BUILDDIR}/chroot"
85 ETC_DIR="${R}/etc"
85 ETC_DIR="${R}/etc"
86 LIB_DIR="${R}/lib"
86 LIB_DIR="${R}/lib"
87 BOOT_DIR="${R}/boot/firmware"
87 BOOT_DIR="${R}/boot/firmware"
88 KERNEL_DIR="${R}/usr/src/linux"
88 KERNEL_DIR="${R}/usr/src/linux"
89 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
89 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
90 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
90 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
91
91
92 # Firmware directory: Blank if download from github
92 # Firmware directory: Blank if download from github
93 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
93 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
94
94
95 # General settings
95 # General settings
96 SET_ARCH=${SET_ARCH:=32}
96 SET_ARCH=${SET_ARCH:=32}
97 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
97 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
98 PASSWORD=${PASSWORD:=raspberry}
98 PASSWORD=${PASSWORD:=raspberry}
99 USER_PASSWORD=${USER_PASSWORD:=raspberry}
99 USER_PASSWORD=${USER_PASSWORD:=raspberry}
100 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
100 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
101 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
101 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
102 EXPANDROOT=${EXPANDROOT:=true}
102 EXPANDROOT=${EXPANDROOT:=true}
103 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
103 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
104
104
105 # Keyboard settings
105 # Keyboard settings
106 XKB_MODEL=${XKB_MODEL:=""}
106 XKB_MODEL=${XKB_MODEL:=""}
107 XKB_LAYOUT=${XKB_LAYOUT:=""}
107 XKB_LAYOUT=${XKB_LAYOUT:=""}
108 XKB_VARIANT=${XKB_VARIANT:=""}
108 XKB_VARIANT=${XKB_VARIANT:=""}
109 XKB_OPTIONS=${XKB_OPTIONS:=""}
109 XKB_OPTIONS=${XKB_OPTIONS:=""}
110
110
111 # Network settings (DHCP)
111 # Network settings (DHCP)
112 ENABLE_DHCP=${ENABLE_DHCP:=true}
112 ENABLE_DHCP=${ENABLE_DHCP:=true}
113
113
114 # Network settings (static)
114 # Network settings (static)
115 NET_ADDRESS=${NET_ADDRESS:=""}
115 NET_ADDRESS=${NET_ADDRESS:=""}
116 NET_GATEWAY=${NET_GATEWAY:=""}
116 NET_GATEWAY=${NET_GATEWAY:=""}
117 NET_DNS_1=${NET_DNS_1:=""}
117 NET_DNS_1=${NET_DNS_1:=""}
118 NET_DNS_2=${NET_DNS_2:=""}
118 NET_DNS_2=${NET_DNS_2:=""}
119 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
119 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
120 NET_NTP_1=${NET_NTP_1:=""}
120 NET_NTP_1=${NET_NTP_1:=""}
121 NET_NTP_2=${NET_NTP_2:=""}
121 NET_NTP_2=${NET_NTP_2:=""}
122
122
123 # APT settings
123 # APT settings
124 APT_PROXY=${APT_PROXY:=""}
124 APT_PROXY=${APT_PROXY:=""}
125 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
125 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
126 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
126 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
127
127
128 # Feature settings
128 # Feature settings
129 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
129 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
130 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
130 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
131 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
131 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
133 ENABLE_I2C=${ENABLE_I2C:=false}
133 ENABLE_I2C=${ENABLE_I2C:=false}
134 ENABLE_SPI=${ENABLE_SPI:=false}
134 ENABLE_SPI=${ENABLE_SPI:=false}
135 ENABLE_IPV6=${ENABLE_IPV6:=true}
135 ENABLE_IPV6=${ENABLE_IPV6:=true}
136 ENABLE_SSHD=${ENABLE_SSHD:=true}
136 ENABLE_SSHD=${ENABLE_SSHD:=true}
137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
139 ENABLE_SOUND=${ENABLE_SOUND:=true}
139 ENABLE_SOUND=${ENABLE_SOUND:=true}
140 ENABLE_DBUS=${ENABLE_DBUS:=true}
140 ENABLE_DBUS=${ENABLE_DBUS:=true}
141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
143 ENABLE_XORG=${ENABLE_XORG:=false}
143 ENABLE_XORG=${ENABLE_XORG:=false}
144 ENABLE_WM=${ENABLE_WM:=""}
144 ENABLE_WM=${ENABLE_WM:=""}
145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
146 ENABLE_USER=${ENABLE_USER:=true}
146 ENABLE_USER=${ENABLE_USER:=true}
147 USER_NAME=${USER_NAME:="pi"}
147 USER_NAME=${USER_NAME:="pi"}
148 ENABLE_ROOT=${ENABLE_ROOT:=false}
148 ENABLE_ROOT=${ENABLE_ROOT:=false}
149 ENABLE_QEMU=${ENABLE_QEMU:=false}
149 ENABLE_QEMU=${ENABLE_QEMU:=false}
150 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
150 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
151
151
152 # SSH settings
152 # SSH settings
153 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
153 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
154 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
154 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
155 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
155 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
156 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
156 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
157 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
157 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
158
158
159 # Advanced settings
159 # Advanced settings
160 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
160 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
161 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
161 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
162 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
162 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
163 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
163 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
164 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
164 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
165 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
165 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
166 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
166 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
167 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
167 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
168 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
168 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
169 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
169 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
170 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
170 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
171 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
171 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
172 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
172 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
173 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
173 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
174 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
174 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
175 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
175 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
176 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
176 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
177 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
177 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
178 ENABLE_LOGO=${ENABLE_LOGO:=true}
178 ENABLE_LOGO=${ENABLE_LOGO:=true}
179 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
179 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
180 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
180 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
181
181
182 # Kernel compilation settings
182 # Kernel compilation settings
183 BUILD_KERNEL=${BUILD_KERNEL:=true}
183 BUILD_KERNEL=${BUILD_KERNEL:=true}
184 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
184 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
185 KERNEL_THREADS=${KERNEL_THREADS:=1}
185 KERNEL_THREADS=${KERNEL_THREADS:=1}
186 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
186 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
187 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
187 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
188 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
188 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
189 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
189 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
190 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
190 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
191 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
191 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
192 KERNEL_VIRT=${KERNEL_VIRT:=false}
192 KERNEL_VIRT=${KERNEL_VIRT:=false}
193 KERNEL_BPF=${KERNEL_BPF:=false}
193 KERNEL_BPF=${KERNEL_BPF:=false}
194 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
194 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
195 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
195 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
196 KERNEL_NF=${KERNEL_NF:=false}
196 KERNEL_NF=${KERNEL_NF:=false}
197
197
198 # Kernel compilation from source directory settings
198 # Kernel compilation from source directory settings
199 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
199 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
200 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
200 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
201 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
201 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
202 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
202 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
203
203
204 # Reduce disk usage settings
204 # Reduce disk usage settings
205 REDUCE_APT=${REDUCE_APT:=true}
205 REDUCE_APT=${REDUCE_APT:=true}
206 REDUCE_DOC=${REDUCE_DOC:=true}
206 REDUCE_DOC=${REDUCE_DOC:=true}
207 REDUCE_MAN=${REDUCE_MAN:=true}
207 REDUCE_MAN=${REDUCE_MAN:=true}
208 REDUCE_VIM=${REDUCE_VIM:=false}
208 REDUCE_VIM=${REDUCE_VIM:=false}
209 REDUCE_BASH=${REDUCE_BASH:=false}
209 REDUCE_BASH=${REDUCE_BASH:=false}
210 REDUCE_HWDB=${REDUCE_HWDB:=true}
210 REDUCE_HWDB=${REDUCE_HWDB:=true}
211 REDUCE_SSHD=${REDUCE_SSHD:=true}
211 REDUCE_SSHD=${REDUCE_SSHD:=true}
212 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
212 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
213
213
214 # Encrypted filesystem settings
214 # Encrypted filesystem settings
215 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
215 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
216 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
216 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
217 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
217 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
218 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
218 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
219 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
219 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
220 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
220 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
221 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
221 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
222 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
222 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
223 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
223 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
224
224
225 # Chroot scripts directory
225 # Chroot scripts directory
226 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
226 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
227
227
228 # Packages required in the chroot build environment
228 # Packages required in the chroot build environment
229 APT_INCLUDES=${APT_INCLUDES:=""}
229 APT_INCLUDES=${APT_INCLUDES:=""}
230 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
230 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
231
231
232 # Packages to exclude from chroot build environment
232 # Packages to exclude from chroot build environment
233 APT_EXCLUDES=${APT_EXCLUDES:=""}
233 APT_EXCLUDES=${APT_EXCLUDES:=""}
234
234
235 # Packages required for bootstrapping
235 # Packages required for bootstrapping
236 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
236 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
237 MISSING_PACKAGES=""
237 MISSING_PACKAGES=""
238
238
239 # Packages installed for c/c++ build environment in chroot (keep empty)
239 # Packages installed for c/c++ build environment in chroot (keep empty)
240 COMPILER_PACKAGES=""
240 COMPILER_PACKAGES=""
241
241
242 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
242 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
243 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
243 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
244 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
244 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
245 APT_PROXY=http://127.0.0.1:3142/
245 APT_PROXY=http://127.0.0.1:3142/
246 fi
246 fi
247
247
248 # Setup architecture specific settings
248 # Setup architecture specific settings
249 if [ -n "$SET_ARCH" ] ; then
249 if [ -n "$SET_ARCH" ] ; then
250 # 64-bit configuration
250 # 64-bit configuration
251 if [ "$SET_ARCH" = 64 ] ; then
251 if [ "$SET_ARCH" = 64 ] ; then
252 # General 64-bit depended settings
252 # General 64-bit depended settings
253 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
253 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
254 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
254 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
255 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
255 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
256
256
257 # Raspberry Pi model specific settings
257 # Raspberry Pi model specific settings
258 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
258 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
259 if [ "$RPI_MODEL" != 4 ] ; then
259 if [ "$RPI_MODEL" != 4 ] ; then
260 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
260 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
261 else
261 else
262 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
262 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
263 fi
263 fi
264
264
265 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
265 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
266 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
266 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
267 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
267 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
268 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
268 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
269 else
269 else
270 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
270 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
271 exit 1
271 exit 1
272 fi
272 fi
273 fi
273 fi
274
274
275 # 32-bit configuration
275 # 32-bit configuration
276 if [ "$SET_ARCH" = 32 ] ; then
276 if [ "$SET_ARCH" = 32 ] ; then
277 # General 32-bit dependend settings
277 # General 32-bit dependend settings
278 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
278 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
279 KERNEL_ARCH=${KERNEL_ARCH:=arm}
279 KERNEL_ARCH=${KERNEL_ARCH:=arm}
280 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
280 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
281
281
282 # Raspberry Pi model specific settings
282 # Raspberry Pi model specific settings
283 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
283 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
284 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
284 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
286 RELEASE_ARCH=${RELEASE_ARCH:=armel}
286 RELEASE_ARCH=${RELEASE_ARCH:=armel}
287 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
287 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
288 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
288 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
289 fi
289 fi
290
290
291 # Raspberry Pi model specific settings
291 # Raspberry Pi model specific settings
292 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
292 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
293 if [ "$RPI_MODEL" != 4 ] ; then
293 if [ "$RPI_MODEL" != 4 ] ; then
294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
295 else
295 else
296 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
296 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
297 fi
297 fi
298
298
299 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
299 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
300 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
300 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
301 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
301 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
302 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
302 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
303 fi
303 fi
304 fi
304 fi
305 # SET_ARCH not set
305 # SET_ARCH not set
306 else
306 else
307 echo "error: Please set '32' or '64' as value for SET_ARCH"
307 echo "error: Please set '32' or '64' as value for SET_ARCH"
308 exit 1
308 exit 1
309 fi
309 fi
310 # Device specific configuration and U-Boot configuration
310 # Device specific configuration and U-Boot configuration
311 case "$RPI_MODEL" in
311 case "$RPI_MODEL" in
312 0)
312 0)
313 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
313 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
314 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
314 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
315 ;;
315 ;;
316 1)
316 1)
317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
319 ;;
319 ;;
320 1P)
320 1P)
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 ;;
323 ;;
324 2)
324 2)
325 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
325 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
327 ;;
327 ;;
328 3)
328 3)
329 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
329 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
331 ;;
331 ;;
332 3P)
332 3P)
333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
335 ;;
335 ;;
336 4)
336 4)
337 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
337 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
339 ;;
339 ;;
340 *)
340 *)
341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
342 exit 1
342 exit 1
343 ;;
343 ;;
344 esac
344 esac
345
345
346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
348 # Include bluetooth packages on supported boards
348 # Include bluetooth packages on supported boards
349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
351 fi
351 fi
352 if [ "$ENABLE_WIRELESS" = true ] ; then
352 if [ "$ENABLE_WIRELESS" = true ] ; then
353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
354 fi
354 fi
355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
356 # Check if the internal wireless interface is not supported by the RPi model
356 # Check if the internal wireless interface is not supported by the RPi model
357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
359 exit 1
359 exit 1
360 fi
360 fi
361 fi
361 fi
362
362
363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
365 exit 1
365 exit 1
366 fi
366 fi
367
367
368 # Prepare date string for default image file name
368 # Prepare date string for default image file name
369 DATE="$(date +%Y-%m-%d)"
369 DATE="$(date +%Y-%m-%d)"
370 if [ -z "$KERNEL_BRANCH" ] ; then
370 if [ -z "$KERNEL_BRANCH" ] ; then
371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
372 else
372 else
373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
374 fi
374 fi
375
375
376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
380 exit 1
380 exit 1
381 fi
381 fi
382 fi
382 fi
383
383
384 # Add cmake to compile videocore sources
384 # Add cmake to compile videocore sources
385 if [ "$ENABLE_VIDEOCORE" = true ] ; then
385 if [ "$ENABLE_VIDEOCORE" = true ] ; then
386 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
386 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
387 fi
387 fi
388
388
389 # Add deps for nexmon
389 # Add deps for nexmon
390 if [ "$ENABLE_NEXMON" = true ] ; then
390 if [ "$ENABLE_NEXMON" = true ] ; then
391 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
391 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
392 fi
392 fi
393
393
394 # Add libncurses5 to enable kernel menuconfig
394 # Add libncurses5 to enable kernel menuconfig
395 if [ "$KERNEL_MENUCONFIG" = true ] ; then
395 if [ "$KERNEL_MENUCONFIG" = true ] ; then
396 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
396 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
397 fi
397 fi
398
398
399 # Add ccache compiler cache for (faster) kernel cross (re)compilation
399 # Add ccache compiler cache for (faster) kernel cross (re)compilation
400 if [ "$KERNEL_CCACHE" = true ] ; then
400 if [ "$KERNEL_CCACHE" = true ] ; then
401 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
401 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
402 fi
402 fi
403
403
404 # Add cryptsetup package to enable filesystem encryption
404 # Add cryptsetup package to enable filesystem encryption
405 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
405 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
406 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
406 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
407 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
407 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
408
408
409 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
409 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
410 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
410 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
411 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
411 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
412 fi
412 fi
413
413
414 if [ -z "$CRYPTFS_PASSWORD" ] ; then
414 if [ -z "$CRYPTFS_PASSWORD" ] ; then
415 echo "error: no password defined (CRYPTFS_PASSWORD)!"
415 echo "error: no password defined (CRYPTFS_PASSWORD)!"
416 exit 1
416 exit 1
417 fi
417 fi
418 ENABLE_INITRAMFS=true
418 ENABLE_INITRAMFS=true
419 fi
419 fi
420
420
421 # Add initramfs generation tools
421 # Add initramfs generation tools
422 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
422 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
423 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
423 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
424 fi
424 fi
425
425
426 # Add device-tree-compiler required for building the U-Boot bootloader
426 # Add device-tree-compiler required for building the U-Boot bootloader
427 if [ "$ENABLE_UBOOT" = true ] ; then
427 if [ "$ENABLE_UBOOT" = true ] ; then
428 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
428 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
429 fi
429 fi
430
430
431 if [ "$ENABLE_USBBOOT" = true ] ; then
431 if [ "$ENABLE_USBBOOT" = true ] ; then
432 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
432 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
433 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
433 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
434 exit 1
434 exit 1
435 fi
435 fi
436 fi
436 fi
437
437
438 # Check if root SSH (v2) public key file exists
438 # Check if root SSH (v2) public key file exists
439 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
439 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
440 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
440 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
441 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
441 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
442 exit 1
442 exit 1
443 fi
443 fi
444 fi
444 fi
445
445
446 # Check if $USER_NAME SSH (v2) public key file exists
446 # Check if $USER_NAME SSH (v2) public key file exists
447 if [ -n "$SSH_USER_PUB_KEY" ] ; then
447 if [ -n "$SSH_USER_PUB_KEY" ] ; then
448 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
448 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
449 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
449 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
450 exit 1
450 exit 1
451 fi
451 fi
452 fi
452 fi
453
453
454 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
454 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
455 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
455 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
456 exit 1
456 exit 1
457 fi
457 fi
458
458
459 # Check if all required packages are installed on the build system
459 # Check if all required packages are installed on the build system
460 for package in $REQUIRED_PACKAGES ; do
460 for package in $REQUIRED_PACKAGES ; do
461 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
461 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
462 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
462 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
463 fi
463 fi
464 done
464 done
465
465
466 # If there are missing packages ask confirmation for install, or exit
466 # If there are missing packages ask confirmation for install, or exit
467 if [ -n "$MISSING_PACKAGES" ] ; then
467 if [ -n "$MISSING_PACKAGES" ] ; then
468 echo "the following packages needed by this script are not installed:"
468 echo "the following packages needed by this script are not installed:"
469 echo "$MISSING_PACKAGES"
469 echo "$MISSING_PACKAGES"
470
470
471 printf "\ndo you want to install the missing packages right now? [y/n] "
471 printf "\ndo you want to install the missing packages right now? [y/n] "
472 read -r confirm
472 read -r confirm
473 [ "$confirm" != "y" ] && exit 1
473 [ "$confirm" != "y" ] && exit 1
474
474
475 # Make sure all missing required packages are installed
475 # Make sure all missing required packages are installed
476 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
476 apt-get -qq -y install "$(echo "${MISSING_PACKAGES}" | sed "s/ //")"
477 fi
477 fi
478
478
479 # Check if ./bootstrap.d directory exists
479 # Check if ./bootstrap.d directory exists
480 if [ ! -d "./bootstrap.d/" ] ; then
480 if [ ! -d "./bootstrap.d/" ] ; then
481 echo "error: './bootstrap.d' required directory not found!"
481 echo "error: './bootstrap.d' required directory not found!"
482 exit 1
482 exit 1
483 fi
483 fi
484
484
485 # Check if ./files directory exists
485 # Check if ./files directory exists
486 if [ ! -d "./files/" ] ; then
486 if [ ! -d "./files/" ] ; then
487 echo "error: './files' required directory not found!"
487 echo "error: './files' required directory not found!"
488 exit 1
488 exit 1
489 fi
489 fi
490
490
491 # Check if specified KERNELSRC_DIR directory exists
491 # Check if specified KERNELSRC_DIR directory exists
492 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
492 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
493 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
493 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
494 exit 1
494 exit 1
495 fi
495 fi
496
496
497 # Check if specified UBOOTSRC_DIR directory exists
497 # Check if specified UBOOTSRC_DIR directory exists
498 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
498 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
499 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
499 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
500 exit 1
500 exit 1
501 fi
501 fi
502
502
503 # Check if specified VIDEOCORESRC_DIR directory exists
503 # Check if specified VIDEOCORESRC_DIR directory exists
504 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
504 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
505 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
505 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
506 exit 1
506 exit 1
507 fi
507 fi
508
508
509 # Check if specified FBTURBOSRC_DIR directory exists
509 # Check if specified FBTURBOSRC_DIR directory exists
510 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
510 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
511 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
511 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
512 exit 1
512 exit 1
513 fi
513 fi
514
514
515 # Check if specified NEXMONSRC_DIR directory exists
515 # Check if specified NEXMONSRC_DIR directory exists
516 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
516 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
517 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
517 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
518 exit 1
518 exit 1
519 fi
519 fi
520
520
521 # Check if specified CHROOT_SCRIPTS directory exists
521 # Check if specified CHROOT_SCRIPTS directory exists
522 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
522 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
523 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
523 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
524 exit 1
524 exit 1
525 fi
525 fi
526
526
527 # Check if specified device mapping already exists (will be used by cryptsetup)
527 # Check if specified device mapping already exists (will be used by cryptsetup)
528 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
528 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
529 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
529 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
530 exit 1
530 exit 1
531 fi
531 fi
532
532
533 # Don't clobber an old build
533 # Don't clobber an old build
534 if [ -e "$BUILDDIR" ] ; then
534 if [ -e "$BUILDDIR" ] ; then
535 echo "error: directory ${BUILDDIR} already exists, not proceeding"
535 echo "error: directory ${BUILDDIR} already exists, not proceeding"
536 exit 1
536 exit 1
537 fi
537 fi
538
538
539 # Setup chroot directory
539 # Setup chroot directory
540 mkdir -p "${R}"
540 mkdir -p "${R}"
541
541
542 # Check if build directory has enough of free disk space >512MB
542 # Check if build directory has enough of free disk space >512MB
543 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
543 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
544 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
544 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
545 exit 1
545 exit 1
546 fi
546 fi
547
547
548 set -x
548 set -x
549
549
550 # Call "cleanup" function on various signals and errors
550 # Call "cleanup" function on various signals and errors
551 trap cleanup 0 1 2 3 6
551 trap cleanup 0 1 2 3 6
552
552
553 # Add required packages for the minbase installation
553 # Add required packages for the minbase installation
554 if [ "$ENABLE_MINBASE" = true ] ; then
554 if [ "$ENABLE_MINBASE" = true ] ; then
555 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
555 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
556 fi
556 fi
557
557
558 # Add parted package, required to get partprobe utility
558 # Add parted package, required to get partprobe utility
559 if [ "$EXPANDROOT" = true ] ; then
559 if [ "$EXPANDROOT" = true ] ; then
560 APT_INCLUDES="${APT_INCLUDES},parted"
560 APT_INCLUDES="${APT_INCLUDES},parted"
561 fi
561 fi
562
562
563 # Add dphys-swapfile package, required to enable swap
563 # Add dphys-swapfile package, required to enable swap
564 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
564 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
565 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
565 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
566 fi
566 fi
567
567
568 # Add dbus package, recommended if using systemd
568 # Add dbus package, recommended if using systemd
569 if [ "$ENABLE_DBUS" = true ] ; then
569 if [ "$ENABLE_DBUS" = true ] ; then
570 APT_INCLUDES="${APT_INCLUDES},dbus"
570 APT_INCLUDES="${APT_INCLUDES},dbus"
571 fi
571 fi
572
572
573 # Add iptables IPv4/IPv6 package
573 # Add iptables IPv4/IPv6 package
574 if [ "$ENABLE_IPTABLES" = true ] ; then
574 if [ "$ENABLE_IPTABLES" = true ] ; then
575 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
575 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
576 fi
576 fi
577 # Add apparmor for KERNEL_SECURITY
577 # Add apparmor for KERNEL_SECURITY
578 if [ "$KERNEL_SECURITY" = true ] ; then
578 if [ "$KERNEL_SECURITY" = true ] ; then
579 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
579 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
580 fi
580 fi
581
581
582 # Add openssh server package
582 # Add openssh server package
583 if [ "$ENABLE_SSHD" = true ] ; then
583 if [ "$ENABLE_SSHD" = true ] ; then
584 APT_INCLUDES="${APT_INCLUDES},openssh-server"
584 APT_INCLUDES="${APT_INCLUDES},openssh-server"
585 fi
585 fi
586
586
587 # Add alsa-utils package
587 # Add alsa-utils package
588 if [ "$ENABLE_SOUND" = true ] ; then
588 if [ "$ENABLE_SOUND" = true ] ; then
589 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
589 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
590 fi
590 fi
591
591
592 # Add rng-tools package
592 # Add rng-tools package
593 if [ "$ENABLE_HWRANDOM" = true ] ; then
593 if [ "$ENABLE_HWRANDOM" = true ] ; then
594 APT_INCLUDES="${APT_INCLUDES},rng-tools"
594 APT_INCLUDES="${APT_INCLUDES},rng-tools"
595 fi
595 fi
596
596
597 # Add fbturbo video driver
597 # Add fbturbo video driver
598 if [ "$ENABLE_FBTURBO" = true ] ; then
598 if [ "$ENABLE_FBTURBO" = true ] ; then
599 # Enable xorg package dependencies
599 # Enable xorg package dependencies
600 ENABLE_XORG=true
600 ENABLE_XORG=true
601 fi
601 fi
602
602
603 # Add user defined window manager package
603 # Add user defined window manager package
604 if [ -n "$ENABLE_WM" ] ; then
604 if [ -n "$ENABLE_WM" ] ; then
605 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
605 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
606
606
607 # Enable xorg package dependencies
607 # Enable xorg package dependencies
608 ENABLE_XORG=true
608 ENABLE_XORG=true
609 fi
609 fi
610
610
611 # Add xorg package
611 # Add xorg package
612 if [ "$ENABLE_XORG" = true ] ; then
612 if [ "$ENABLE_XORG" = true ] ; then
613 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
613 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
614 fi
614 fi
615
615
616 # Replace selected packages with smaller clones
616 # Replace selected packages with smaller clones
617 if [ "$ENABLE_REDUCE" = true ] ; then
617 if [ "$ENABLE_REDUCE" = true ] ; then
618 # Add levee package instead of vim-tiny
618 # Add levee package instead of vim-tiny
619 if [ "$REDUCE_VIM" = true ] ; then
619 if [ "$REDUCE_VIM" = true ] ; then
620 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
620 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
621 fi
621 fi
622
622
623 # Add dropbear package instead of openssh-server
623 # Add dropbear package instead of openssh-server
624 if [ "$REDUCE_SSHD" = true ] ; then
624 if [ "$REDUCE_SSHD" = true ] ; then
625 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
625 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
626 fi
626 fi
627 fi
627 fi
628
628
629 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
629 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
630 if [ "$ENABLE_SYSVINIT" = false ] ; then
630 if [ "$ENABLE_SYSVINIT" = false ] ; then
631 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
631 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
632 fi
632 fi
633
633
634 # Configure kernel sources if no KERNELSRC_DIR
634 # Configure kernel sources if no KERNELSRC_DIR
635 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
635 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
636 KERNELSRC_CONFIG=true
636 KERNELSRC_CONFIG=true
637 fi
637 fi
638
638
639 # Configure reduced kernel
639 # Configure reduced kernel
640 if [ "$KERNEL_REDUCE" = true ] ; then
640 if [ "$KERNEL_REDUCE" = true ] ; then
641 KERNELSRC_CONFIG=false
641 KERNELSRC_CONFIG=false
642 fi
642 fi
643
643
644 # Configure qemu compatible kernel
644 # Configure qemu compatible kernel
645 if [ "$ENABLE_QEMU" = true ] ; then
645 if [ "$ENABLE_QEMU" = true ] ; then
646 DTB_FILE=vexpress-v2p-ca15_a7.dtb
646 DTB_FILE=vexpress-v2p-ca15_a7.dtb
647 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
647 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
648 KERNEL_DEFCONFIG="vexpress_defconfig"
648 KERNEL_DEFCONFIG="vexpress_defconfig"
649 if [ "$KERNEL_MENUCONFIG" = false ] ; then
649 if [ "$KERNEL_MENUCONFIG" = false ] ; then
650 KERNEL_OLDDEFCONFIG=true
650 KERNEL_OLDDEFCONFIG=true
651 fi
651 fi
652 fi
652 fi
653
653
654 # Execute bootstrap scripts
654 # Execute bootstrap scripts
655 for SCRIPT in bootstrap.d/*.sh; do
655 for SCRIPT in bootstrap.d/*.sh; do
656 head -n 3 "$SCRIPT"
656 head -n 3 "$SCRIPT"
657 . "$SCRIPT"
657 . "$SCRIPT"
658 done
658 done
659
659
660 ## Execute custom bootstrap scripts
660 ## Execute custom bootstrap scripts
661 if [ -d "custom.d" ] ; then
661 if [ -d "custom.d" ] ; then
662 for SCRIPT in custom.d/*.sh; do
662 for SCRIPT in custom.d/*.sh; do
663 . "$SCRIPT"
663 . "$SCRIPT"
664 done
664 done
665 fi
665 fi
666
666
667 # Execute custom scripts inside the chroot
667 # Execute custom scripts inside the chroot
668 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
668 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
669 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
669 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
670 chroot_exec /bin/bash -x <<'EOF'
670 chroot_exec /bin/bash -x <<'EOF'
671 for SCRIPT in /chroot_scripts/* ; do
671 for SCRIPT in /chroot_scripts/* ; do
672 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
672 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
673 $SCRIPT
673 $SCRIPT
674 fi
674 fi
675 done
675 done
676 EOF
676 EOF
677 rm -rf "${R}/chroot_scripts"
677 rm -rf "${R}/chroot_scripts"
678 fi
678 fi
679
679
680 # Remove c/c++ build environment from the chroot
680 # Remove c/c++ build environment from the chroot
681 chroot_remove_cc
681 chroot_remove_cc
682
682
683 # Generate required machine-id
683 # Generate required machine-id
684 MACHINE_ID=$(dbus-uuidgen)
684 MACHINE_ID=$(dbus-uuidgen)
685 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
685 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
686 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
686 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
687
687
688 # APT Cleanup
688 # APT Cleanup
689 chroot_exec apt-get -y clean
689 chroot_exec apt-get -y clean
690 chroot_exec apt-get -y autoclean
690 chroot_exec apt-get -y autoclean
691 chroot_exec apt-get -y autoremove
691 chroot_exec apt-get -y autoremove
692
692
693 # Unmount mounted filesystems
693 # Unmount mounted filesystems
694 umount -l "${R}/proc"
694 umount -l "${R}/proc"
695 umount -l "${R}/sys"
695 umount -l "${R}/sys"
696
696
697 # Clean up directories
697 # Clean up directories
698 rm -rf "${R}/run/*"
698 rm -rf "${R}/run/*"
699 rm -rf "${R}/tmp/*"
699 rm -rf "${R}/tmp/*"
700
700
701 # Clean up APT proxy settings
701 # Clean up APT proxy settings
702 if [ "$KEEP_APT_PROXY" = false ] ; then
702 if [ "$KEEP_APT_PROXY" = false ] ; then
703 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
703 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
704 fi
704 fi
705
705
706 # Clean up files
706 # Clean up files
707 rm -f "${ETC_DIR}/ssh/ssh_host_*"
707 rm -f "${ETC_DIR}/ssh/ssh_host_*"
708 rm -f "${ETC_DIR}/dropbear/dropbear_*"
708 rm -f "${ETC_DIR}/dropbear/dropbear_*"
709 rm -f "${ETC_DIR}/apt/sources.list.save"
709 rm -f "${ETC_DIR}/apt/sources.list.save"
710 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
710 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
711 rm -f "${ETC_DIR}/*-"
711 rm -f "${ETC_DIR}/*-"
712 rm -f "${ETC_DIR}/resolv.conf"
712 rm -f "${ETC_DIR}/resolv.conf"
713 rm -f "${R}/root/.bash_history"
713 rm -f "${R}/root/.bash_history"
714 rm -f "${R}/var/lib/urandom/random-seed"
714 rm -f "${R}/var/lib/urandom/random-seed"
715 rm -f "${R}/initrd.img"
715 rm -f "${R}/initrd.img"
716 rm -f "${R}/vmlinuz"
716 rm -f "${R}/vmlinuz"
717 rm -f "${R}${QEMU_BINARY}"
717 rm -f "${R}${QEMU_BINARY}"
718
718
719 if [ "$ENABLE_QEMU" = true ] ; then
719 if [ "$ENABLE_QEMU" = true ] ; then
720 # Setup QEMU directory
720 # Setup QEMU directory
721 mkdir "${BASEDIR}/qemu"
721 mkdir "${BASEDIR}/qemu"
722
722
723 # Copy kernel image to QEMU directory
723 # Copy kernel image to QEMU directory
724 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
724 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
725
725
726 # Copy kernel config to QEMU directory
726 # Copy kernel config to QEMU directory
727 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
727 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
728
728
729 # Copy kernel dtbs to QEMU directory
729 # Copy kernel dtbs to QEMU directory
730 for dtb in "${BOOT_DIR}/"*.dtb ; do
730 for dtb in "${BOOT_DIR}/"*.dtb ; do
731 if [ -f "${dtb}" ] ; then
731 if [ -f "${dtb}" ] ; then
732 install_readonly "${dtb}" "${BASEDIR}/qemu/"
732 install_readonly "${dtb}" "${BASEDIR}/qemu/"
733 fi
733 fi
734 done
734 done
735
735
736 # Copy kernel overlays to QEMU directory
736 # Copy kernel overlays to QEMU directory
737 if [ -d "${BOOT_DIR}/overlays" ] ; then
737 if [ -d "${BOOT_DIR}/overlays" ] ; then
738 # Setup overlays dtbs directory
738 # Setup overlays dtbs directory
739 mkdir "${BASEDIR}/qemu/overlays"
739 mkdir "${BASEDIR}/qemu/overlays"
740
740
741 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
741 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
742 if [ -f "${dtb}" ] ; then
742 if [ -f "${dtb}" ] ; then
743 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
743 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
744 fi
744 fi
745 done
745 done
746 fi
746 fi
747
747
748 # Copy u-boot files to QEMU directory
748 # Copy u-boot files to QEMU directory
749 if [ "$ENABLE_UBOOT" = true ] ; then
749 if [ "$ENABLE_UBOOT" = true ] ; then
750 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
750 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
751 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
751 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
752 fi
752 fi
753 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
753 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
754 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
754 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
755 fi
755 fi
756 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
756 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
757 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
757 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
758 fi
758 fi
759 fi
759 fi
760
760
761 # Copy initramfs to QEMU directory
761 # Copy initramfs to QEMU directory
762 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
762 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
763 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
763 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
764 fi
764 fi
765 fi
765 fi
766
766
767 # Calculate size of the chroot directory in KB
767 # Calculate size of the chroot directory in KB
768 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
768 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
769
769
770 # Calculate the amount of needed 512 Byte sectors
770 # Calculate the amount of needed 512 Byte sectors
771 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
771 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
772 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
772 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
773 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
773 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
774
774
775 # The root partition is EXT4
775 # The root partition is EXT4
776 # This means more space than the actual used space of the chroot is used.
776 # This means more space than the actual used space of the chroot is used.
777 # As overhead for journaling and reserved blocks 35% are added.
777 # As overhead for journaling and reserved blocks 35% are added.
778 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
778 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
779
779
780 # Calculate required image size in 512 Byte sectors
780 # Calculate required image size in 512 Byte sectors
781 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
781 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
782
782
783 # Prepare image file
783 # Prepare image file
784 if [ "$ENABLE_SPLITFS" = true ] ; then
784 if [ "$ENABLE_SPLITFS" = true ] ; then
785 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
785 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
786 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
786 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
787 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
787 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
788 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
788 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
789
789
790 # Write firmware/boot partition tables
790 # Write firmware/boot partition tables
791 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
791 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
792 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
792 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
793 EOM
793 EOM
794
794
795 # Write root partition table
795 # Write root partition table
796 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
796 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
797 ${TABLE_SECTORS},${ROOT_SECTORS},83
797 ${TABLE_SECTORS},${ROOT_SECTORS},83
798 EOM
798 EOM
799
799
800 # Setup temporary loop devices
800 # Setup temporary loop devices
801 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
801 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
802 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
802 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
803 else # ENABLE_SPLITFS=false
803 else # ENABLE_SPLITFS=false
804 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
804 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
805 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
805 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
806
806
807 # Write partition table
807 # Write partition table
808 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
808 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
809 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
809 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
810 ${ROOT_OFFSET},${ROOT_SECTORS},83
810 ${ROOT_OFFSET},${ROOT_SECTORS},83
811 EOM
811 EOM
812
812
813 # Setup temporary loop devices
813 # Setup temporary loop devices
814 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
814 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
815 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
815 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
816 fi
816 fi
817
817
818 if [ "$ENABLE_CRYPTFS" = true ] ; then
818 if [ "$ENABLE_CRYPTFS" = true ] ; then
819 # Create dummy ext4 fs
819 # Create dummy ext4 fs
820 mkfs.ext4 "$ROOT_LOOP"
820 mkfs.ext4 "$ROOT_LOOP"
821
821
822 # Setup password keyfile
822 # Setup password keyfile
823 touch .password
823 touch .password
824 chmod 600 .password
824 chmod 600 .password
825 echo -n ${CRYPTFS_PASSWORD} > .password
825 echo -n ${CRYPTFS_PASSWORD} > .password
826
826
827 # Initialize encrypted partition
827 # Initialize encrypted partition
828 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
828 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
829
829
830 # Open encrypted partition and setup mapping
830 # Open encrypted partition and setup mapping
831 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
831 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
832
832
833 # Secure delete password keyfile
833 # Secure delete password keyfile
834 shred -zu .password
834 shred -zu .password
835
835
836 # Update temporary loop device
836 # Update temporary loop device
837 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
837 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
838
838
839 # Wipe encrypted partition (encryption cipher is used for randomness)
839 # Wipe encrypted partition (encryption cipher is used for randomness)
840 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
840 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
841 fi
841 fi
842
842
843 # Build filesystems
843 # Build filesystems
844 mkfs.vfat "$FRMW_LOOP"
844 mkfs.vfat "$FRMW_LOOP"
845 mkfs.ext4 "$ROOT_LOOP"
845 mkfs.ext4 "$ROOT_LOOP"
846
846
847 # Mount the temporary loop devices
847 # Mount the temporary loop devices
848 mkdir -p "$BUILDDIR/mount"
848 mkdir -p "$BUILDDIR/mount"
849 mount "$ROOT_LOOP" "$BUILDDIR/mount"
849 mount "$ROOT_LOOP" "$BUILDDIR/mount"
850
850
851 mkdir -p "$BUILDDIR/mount/boot/firmware"
851 mkdir -p "$BUILDDIR/mount/boot/firmware"
852 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
852 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
853
853
854 # Copy all files from the chroot to the loop device mount point directory
854 # Copy all files from the chroot to the loop device mount point directory
855 rsync -a "${R}/" "$BUILDDIR/mount/"
855 rsync -a "${R}/" "$BUILDDIR/mount/"
856
856
857 # Unmount all temporary loop devices and mount points
857 # Unmount all temporary loop devices and mount points
858 cleanup
858 cleanup
859
859
860 # Create block map file(s) of image(s)
860 # Create block map file(s) of image(s)
861 if [ "$ENABLE_SPLITFS" = true ] ; then
861 if [ "$ENABLE_SPLITFS" = true ] ; then
862 # Create block map files for "bmaptool"
862 # Create block map files for "bmaptool"
863 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
863 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
864 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
864 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
865
865
866 # Image was successfully created
866 # Image was successfully created
867 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
867 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
868 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
868 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
869 else
869 else
870 # Create block map file for "bmaptool"
870 # Create block map file for "bmaptool"
871 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
871 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
872
872
873 # Image was successfully created
873 # Image was successfully created
874 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
874 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
875
875
876 # Create qemu qcow2 image
876 # Create qemu qcow2 image
877 if [ "$ENABLE_QEMU" = true ] ; then
877 if [ "$ENABLE_QEMU" = true ] ; then
878 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
878 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
879 QEMU_SIZE=16G
879 QEMU_SIZE=16G
880
880
881 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
881 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
882 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
882 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
883
883
884 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
884 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
885 fi
885 fi
886 fi
886 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant